#include <windows.h>
#include "color.h"

//---------------------------------------------------------------------
//      FϊvOC\̒`
//---------------------------------------------------------------------
COLOR_PLUGIN_TABLE color_plugin_table = {
    NULL,
    "ϊ",
    "ϊ Ver.110810",
    NULL,
    NULL,
    func_pixel2yc,
    func_yc2pixel,
};

//---------------------------------------------------------------------
//      FϊvOC\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C COLOR_PLUGIN_TABLE __declspec(dllexport) * __stdcall GetColorPluginTable( void )
{
    return &color_plugin_table;
}

const __declspec(align(16)) short i128_pw_19152_18725[8] = {19152, 18725, 19152, 18725, 19152, 18725, 19152, 18725};
const __declspec(align(16)) short i128_pw_299_2340[8] = {299, 2340, 299, 2340, 299, 2340, 299, 2340};
const __declspec(align(16)) BYTE shufb1[16] = {0,  1,  2,  3,  6,  7,  4,  5,  2,  3,  6,  7,  8,  9, 10, 11};
const __declspec(align(16)) BYTE shufb2[16] = {0,  1,  2,  3,  6,  7,  4,  5, 10, 11, 14, 15,  8,  9, 10, 11};
const __declspec(align(16)) BYTE shufb3[16] = {6,  7,  4,  5,  2,  3,  6,  7,  8,  9, 10, 11, 14, 15, 12, 13};
const __declspec(align(16)) BYTE shufb4[16] = {6,  7,  4,  5, 10, 11, 14, 15,  8,  9, 10, 11, 14, 15, 12, 13}; 
const __declspec(align(16)) BYTE shufb5[16] = {2,  3,  6,  7,  8,  9, 10, 11, 14, 15, 12, 13, 10, 11, 14, 15};
const __declspec(align(16)) BYTE shufb6[16] = {2,  3,  6,  7,  0,  1,  2,  3,  6,  7,  4,  5, 10, 11, 14, 15};
const __declspec(align(16)) BYTE shufb7[16] ={10, 11, 14, 15,  8,  9, 10, 11, 14, 15, 12, 13, 10, 11, 14, 15};

const __declspec(align(16)) short i128_pw_301_2350[8] = {301, 2350, 301, 2350, 301, 2350, 301, 2350};
const __declspec(align(16)) short i128_pw_3504_3584[8] = {3504, 3584, 3504, 3584, 3504, 3584, 3504, 3584};
const __declspec(align(16)) BYTE shufb9[16] =  {  0,  1,  2,  3,  6,  7,  4,  5, 12, 13, 14, 15, -1, -1, -1, -1};
const __declspec(align(16)) BYTE shufb10[16] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  2,  3,  0,  1};
const __declspec(align(16)) BYTE shufb11[16] = {  8,  9, 10, 11, 14, 15, 12, 13, -1, -1, -1, -1, -1, -1, -1, -1};
const __declspec(align(16)) BYTE shufb12[16] = { -1, -1, -1, -1, -1, -1, -1, -1,  4,  5,  6,  7, 10, 11,  8,  9};

void yuy2_to_yc48(int thread_id, int thread_num, void *param1, void *param2)
{
    COLOR_PROC_INFO *cpip  = (COLOR_PROC_INFO *)param1;
    int w = cpip->w;
    int h = cpip->h;
    int y_start = h * thread_id / thread_num;
    int y_end = h * (thread_id+1) / thread_num;
    int src_bpl = w*2;
    int dest_bpl = cpip->line_size;
    int xloopcount = w / 8 - 4;
    int yloopcount = y_end - y_start;
    int srcstep = src_bpl - (xloopcount+3) * 16;
    int deststep = dest_bpl - (xloopcount+3) * 48;
    BYTE* src = (BYTE*)cpip->pixelp + src_bpl * y_start;
    BYTE* dest = (BYTE*)cpip->ycp + dest_bpl * y_start;
    __asm
    {
        pxor            xmm7, xmm7
        mov             esi, src
        mov             edi, dest
        mov             eax, yloopcount
        mov             edx, src_bpl
        
    align 16
    yloop:
        mov             ecx, xloopcount
        movq            xmm0, mmword ptr [esi]
        punpcklbw       xmm0, xmm7
        psllw           xmm0, 6
        pmulhw          xmm0, i128_pw_19152_18725
        psubsw          xmm0, i128_pw_299_2340
    align 16
    xloop:
        movq            xmm1, mmword ptr [esi+8]
        movq            xmm2, mmword ptr [esi+16]
        prefetchnta     [esi+edx]
        punpcklbw       xmm1, xmm7
        punpcklbw       xmm2, xmm7
        psllw           xmm1, 6
        psllw           xmm2, 6
        pmulhw          xmm1, i128_pw_19152_18725
        pmulhw          xmm2, i128_pw_19152_18725
        psubsw          xmm1, i128_pw_299_2340
        psubsw          xmm2, i128_pw_299_2340
        movdqa          xmm3, xmm0
        movdqa          xmm4, xmm1
        psrldq          xmm3, 8
        psrldq          xmm4, 8
        punpcklqdq      xmm3, xmm1
        punpcklqdq      xmm4, xmm2
        movdqa          xmm5, xmm0
        movdqa          xmm6, xmm3
        pshufb          xmm5, shufb1
        pshufb          xmm0, shufb2
        pshufb          xmm6, shufb3
        pshufb          xmm3, shufb4
        pshufb          xmm1, shufb5
        pshufb          xmm4, shufb6
        paddsw          xmm5, xmm0
        paddsw          xmm6, xmm3
        paddsw          xmm1, xmm4
        psraw           xmm5, 1
        psraw           xmm6, 1
        psraw           xmm1, 1
        movntdq         [edi], xmm5
        movntdq         [edi+16], xmm6
        movntdq         [edi+32], xmm1

        movq            xmm0, mmword ptr [esi+24]
        movq            xmm1, mmword ptr [esi+32]
        punpcklbw       xmm0, xmm7
        punpcklbw       xmm1, xmm7
        psllw           xmm0, 6
        psllw           xmm1, 6
        pmulhw          xmm0, i128_pw_19152_18725
        pmulhw          xmm1, i128_pw_19152_18725
        psubsw          xmm0, i128_pw_299_2340
        psubsw          xmm1, i128_pw_299_2340
        movdqa          xmm3, xmm2
        movdqa          xmm4, xmm0
        psrldq          xmm3, 8
        psrldq          xmm4, 8
        punpcklqdq      xmm3, xmm0
        punpcklqdq      xmm4, xmm1
        movdqa          xmm5, xmm2
        movdqa          xmm6, xmm3
        pshufb          xmm5, shufb1
        pshufb          xmm2, shufb2
        pshufb          xmm6, shufb3
        pshufb          xmm3, shufb4
        pshufb          xmm0, shufb5
        pshufb          xmm4, shufb6
        paddsw          xmm5, xmm2
        paddsw          xmm6, xmm3
        paddsw          xmm0, xmm4
        psraw           xmm5, 1
        psraw           xmm6, 1
        psraw           xmm0, 1
        movntdq         [edi+48], xmm5
        movntdq         [edi+64], xmm6
        movntdq         [edi+80], xmm0

        movq            xmm2, mmword ptr [esi+40]
        movq            xmm0, mmword ptr [esi+48]
        punpcklbw       xmm2, xmm7
        punpcklbw       xmm0, xmm7
        psllw           xmm2, 6
        psllw           xmm0, 6
        pmulhw          xmm2, i128_pw_19152_18725
        pmulhw          xmm0, i128_pw_19152_18725
        psubsw          xmm2, i128_pw_299_2340
        psubsw          xmm0, i128_pw_299_2340
        movdqa          xmm3, xmm1
        movdqa          xmm4, xmm2
        psrldq          xmm3, 8
        psrldq          xmm4, 8
        punpcklqdq      xmm3, xmm2
        punpcklqdq      xmm4, xmm0
        movdqa          xmm5, xmm1
        movdqa          xmm6, xmm3
        pshufb          xmm5, shufb1
        pshufb          xmm1, shufb2
        pshufb          xmm6, shufb3
        pshufb          xmm3, shufb4
        pshufb          xmm2, shufb5
        pshufb          xmm4, shufb6
        paddsw          xmm5, xmm1
        paddsw          xmm6, xmm3
        paddsw          xmm2, xmm4
        psraw           xmm5, 1
        psraw           xmm6, 1
        psraw           xmm2, 1
        movntdq         [edi+96], xmm5
        movntdq         [edi+112], xmm6
        movntdq         [edi+128], xmm2

        movq            xmm1, mmword ptr [esi+56]
        movq            xmm2, mmword ptr [esi+64]
        punpcklbw       xmm1, xmm7
        punpcklbw       xmm2, xmm7
        psllw           xmm1, 6
        psllw           xmm2, 6
        pmulhw          xmm1, i128_pw_19152_18725
        pmulhw          xmm2, i128_pw_19152_18725
        psubsw          xmm1, i128_pw_299_2340
        psubsw          xmm2, i128_pw_299_2340
        movdqa          xmm3, xmm0
        movdqa          xmm4, xmm1
        psrldq          xmm3, 8
        psrldq          xmm4, 8
        punpcklqdq      xmm3, xmm1
        punpcklqdq      xmm4, xmm2
        movdqa          xmm5, xmm0
        movdqa          xmm6, xmm3
        pshufb          xmm5, shufb1
        pshufb          xmm0, shufb2
        pshufb          xmm6, shufb3
        pshufb          xmm3, shufb4
        pshufb          xmm1, shufb5
        pshufb          xmm4, shufb6
        paddsw          xmm5, xmm0
        paddsw          xmm6, xmm3
        paddsw          xmm1, xmm4
        psraw           xmm5, 1
        psraw           xmm6, 1
        psraw           xmm1, 1
        movntdq         [edi+144], xmm5
        movntdq         [edi+160], xmm6
        movntdq         [edi+176], xmm1
        movdqa          xmm0, xmm2
        add             esi, 64
        add             edi, 192
        sub             ecx, 4
        jnle            xloop
        prefetchnta     [esi+edx]
        add             ecx, 3
        jz              xloop2_end
        
    align 16
    xloop2:
        movq            xmm1, mmword ptr [esi+8]
        movq            xmm2, mmword ptr [esi+16]
        punpcklbw       xmm1, xmm7
        punpcklbw       xmm2, xmm7
        psllw           xmm1, 6
        psllw           xmm2, 6
        pmulhw          xmm1, i128_pw_19152_18725
        pmulhw          xmm2, i128_pw_19152_18725
        psubsw          xmm1, i128_pw_299_2340
        psubsw          xmm2, i128_pw_299_2340
        movdqa          xmm3, xmm0
        movdqa          xmm4, xmm1
        psrldq          xmm3, 8
        psrldq          xmm4, 8
        punpcklqdq      xmm3, xmm1
        punpcklqdq      xmm4, xmm2
        movdqa          xmm5, xmm0
        movdqa          xmm6, xmm3
        pshufb          xmm5, shufb1
        pshufb          xmm0, shufb2
        pshufb          xmm6, shufb3
        pshufb          xmm3, shufb4
        pshufb          xmm1, shufb5
        pshufb          xmm4, shufb6
        paddsw          xmm5, xmm0
        paddsw          xmm6, xmm3
        paddsw          xmm1, xmm4
        psraw           xmm5, 1
        psraw           xmm6, 1
        psraw           xmm1, 1
        movntdq         [edi], xmm5
        movntdq         [edi+16], xmm6
        movntdq         [edi+32], xmm1
        movdqa          xmm0, xmm2
        add             esi, 16
        add             edi, 48
        sub             ecx, 1
        jnz             xloop2
    xloop2_end:
        movq            xmm1, mmword ptr [esi+8]
        punpcklbw       xmm1, xmm7
        psllw           xmm1, 6
        pmulhw          xmm1, i128_pw_19152_18725
        psubsw          xmm1, i128_pw_299_2340
        movdqa          xmm2, xmm0
        psrldq          xmm2, 8
        punpcklqdq      xmm2, xmm1
        movdqa          xmm3, xmm0
        movdqa          xmm4, xmm2
        movdqa          xmm5, xmm1
        pshufb          xmm3, shufb1
        pshufb          xmm0, shufb2
        pshufb          xmm4, shufb3
        pshufb          xmm2, shufb4
        pshufb          xmm5, shufb5
        pshufb          xmm1, shufb7
        paddsw          xmm3, xmm0
        paddsw          xmm4, xmm2
        paddsw          xmm5, xmm1
        psraw           xmm3, 1
        psraw           xmm4, 1
        psraw           xmm5, 1
        movntdq         [edi], xmm3
        movntdq         [edi+16], xmm4
        movntdq         [edi+32], xmm5
        add             esi, srcstep
        add             edi, deststep
        sub             eax, 1
        jnz             yloop
    }
}

void yc48_to_yuy2(int thread_id, int thread_num, void *param1, void *param2)
{
    COLOR_PROC_INFO *cpip  = (COLOR_PROC_INFO *)param1;
    int w = cpip->w;
    int h = cpip->h;
    int y_start = h * thread_id / thread_num;
    int y_end = h * (thread_id+1) / thread_num;
    int src_bpl = cpip->line_size;
    int dest_bpl = w*2;
    int xloopcount = w / 8 - 3;
    int yloopcount = y_end - y_start;
    int srcstep = src_bpl - (xloopcount+3) * 48;
    BYTE* src = (BYTE*)cpip->ycp + src_bpl * y_start;
    BYTE* dest = (BYTE*)cpip->pixelp + dest_bpl * y_start;
    __asm
    {
        mov             esi, src
        mov             edi, dest
        mov             eax, yloopcount
        mov             edx, src_bpl
        movdqa          xmm7, i128_pw_301_2350
        movdqa          xmm6, i128_pw_3504_3584
        movdqa          xmm5, shufb9
        movdqa          xmm4, shufb10
    yloop:
        mov             ecx, xloopcount
    align 16
    xloop:
        prefetchnta     [esi+edx]
        prefetchnta     [esi+edx+64]
        prefetchnta     [esi+edx+128]
        movdqa          xmm0, [esi]
        movdqa          xmm1, [esi+16]
        movdqa          xmm2, [esi+32]
        movdqa          xmm3, xmm1
        pshufb          xmm0, xmm5
        pshufb          xmm3, xmm4
        pshufb          xmm1, shufb11
        pshufb          xmm2, shufb12
        paddsw          xmm0, xmm3
        paddsw          xmm1, xmm2
        paddsw          xmm0, xmm7
        paddsw          xmm1, xmm7
        pmulhw          xmm0, xmm6
        pmulhw          xmm1, xmm6
        packuswb        xmm0, xmm1
        movntdq         [edi], xmm0
        
        movdqa          xmm0, [esi+48]
        movdqa          xmm1, [esi+64]
        movdqa          xmm2, [esi+80]
        movdqa          xmm3, xmm1
        pshufb          xmm0, xmm5
        pshufb          xmm3, xmm4
        pshufb          xmm1, shufb11
        pshufb          xmm2, shufb12
        paddsw          xmm0, xmm3
        paddsw          xmm1, xmm2
        paddsw          xmm0, xmm7
        paddsw          xmm1, xmm7
        pmulhw          xmm0, xmm6
        pmulhw          xmm1, xmm6
        packuswb        xmm0, xmm1
        movntdq         [edi+16], xmm0
        
        movdqa          xmm0, [esi+96]
        movdqa          xmm1, [esi+112]
        movdqa          xmm2, [esi+128]
        movdqa          xmm3, xmm1
        pshufb          xmm0, xmm5
        pshufb          xmm3, xmm4
        pshufb          xmm1, shufb11
        pshufb          xmm2, shufb12
        paddsw          xmm0, xmm3
        paddsw          xmm1, xmm2
        paddsw          xmm0, xmm7
        paddsw          xmm1, xmm7
        pmulhw          xmm0, xmm6
        pmulhw          xmm1, xmm6
        packuswb        xmm0, xmm1
        movntdq         [edi+32], xmm0
        
        movdqa          xmm0, [esi+144]
        movdqa          xmm1, [esi+160]
        movdqa          xmm2, [esi+176]
        movdqa          xmm3, xmm1
        pshufb          xmm0, xmm5
        pshufb          xmm3, xmm4
        pshufb          xmm1, shufb11
        pshufb          xmm2, shufb12
        paddsw          xmm0, xmm3
        paddsw          xmm1, xmm2
        paddsw          xmm0, xmm7
        paddsw          xmm1, xmm7
        pmulhw          xmm0, xmm6
        pmulhw          xmm1, xmm6
        packuswb        xmm0, xmm1
        movntdq         [edi+48], xmm0
        add             esi, 192
        add             edi, 64
        sub             ecx, 4
        jnle            xloop
        
        add             ecx, 3
        jz              xloop2_end
    align 16
    xloop2:
        prefetchnta     [esi+edx]
        movdqa          xmm0, [esi]
        movdqa          xmm1, [esi+16]
        movdqa          xmm2, [esi+32]
        movdqa          xmm3, xmm1
        pshufb          xmm0, xmm5
        pshufb          xmm3, xmm4
        pshufb          xmm1, shufb11
        pshufb          xmm2, shufb12
        paddsw          xmm0, xmm3
        paddsw          xmm1, xmm2
        paddsw          xmm0, xmm7
        paddsw          xmm1, xmm7
        pmulhw          xmm0, xmm6
        pmulhw          xmm1, xmm6
        packuswb        xmm0, xmm1
        movntdq         [edi], xmm0
        add             esi, 48
        add             edi, 16
        sub             ecx, 1
        jnz             xloop2
    xloop2_end:
        add             esi, srcstep
        sub             eax, 1
        jnz             yloop
    }
}

BOOL func_pixel2yc( COLOR_PROC_INFO *cpip )
{
    if(cpip->format != MAKEFOURCC('Y','U','Y','2') ) return FALSE;
    if((cpip->w & 7) != 0) return FALSE;
    yuy2_to_yc48(0, 1, (void*)cpip, NULL);
    return TRUE;
}

BOOL func_yc2pixel( COLOR_PROC_INFO *cpip )
{
    if(cpip->format != MAKEFOURCC('Y','U','Y','2') ) return FALSE;
    if((cpip->w & 7) != 0) return FALSE;
    yc48_to_yuy2(0, 1, (void*)cpip, NULL);
    return TRUE;
}